#NEEK HSMC SDC Constraints

proc create_neek_lcd_interface_constraints {HSMC_PORT_BASE_NAME} {
	#Eth
	#rxclk
	set rxclk_name $HSMC_PORT_BASE_NAME
	append rxclk_name "_neek_eth_rx_clk"
	set rxclk_port_name $HSMC_PORT_BASE_NAME
	append rxclk_port_name "_clk_in_p_cmos[1]"
	create_clock -period 20 -name $rxclk_name [get_ports $rxclk_port_name]
	#txclk
	set txclk_name $HSMC_PORT_BASE_NAME
	append txclk_name "_neek_eth_tx_clk"
	set txclk_port_name $HSMC_PORT_BASE_NAME
	append txclk_port_name "_clk_in_n_cmos[2]"
	create_clock -period 20 -name $txclk_name [get_ports $txclk_port_name]
	
	#Cut the timing path betweeen unrelated clock domains
	set_clock_groups -exclusive -group $txclk_name -group $rxclk_name
	set_clock_groups -exclusive -group $rxclk_name -group $txclk_name
	set_false_path -from [get_clocks $txclk_name] -to [get_clocks *]
	set_false_path -from [get_clocks $rxclk_name] -to [get_clocks *]
	set_false_path -to [get_clocks $txclk_name] -from [get_clocks *]
	set_false_path -to [get_clocks $rxclk_name] -from [get_clocks *]
	
	#VGA
	set vga_clk_name $HSMC_PORT_BASE_NAME
	append vga_clk_name "_vga_clk"
	set vga_clk_pin $HSMC_PORT_BASE_NAME
	append vga_clk_pin "_clk_out_n_cmos[1]"
	create_clock -period 10 -name $vga_clk_name [get_ports $vga_clk_pin]
	
	#VGA IO
	set vga_pins "_d_a[16] _d_a[18] _d_a[20] _d_a[22] _d_a[24] _d_a[26] _d_a[28] _d_a[30] _d_a[32] _d_a[34] _d_a[12] _d_a[14] _d_a[9] _d_a[10]"
	foreach pin $vga_pins {
		set base $HSMC_PORT_BASE_NAME
		append base $pin
		set_output_delay -clock [get_clocks $vga_clk_name] -max 8 [get_ports $base] 	
		set_output_delay -clock [get_clocks $vga_clk_name] -min 2 [get_ports $base] 	
	}

}
